<html>
<head>
<title>OgreDualQuaternion.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreDualQuaternion.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreDualQuaternion_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef __DualQuaternion_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define __DualQuaternion_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreMath_8h.html">OgreMath.h</a>&quot;</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="keyword">namespace </span>Ogre {
<a name="l00036"></a>00036 
<a name="l00047"></a><a class="code" href="classOgre_1_1DualQuaternion.html">00047</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1DualQuaternion.html" title="Implementation of a dual quaternion, i.e.">DualQuaternion</a>
<a name="l00048"></a>00048     {
<a name="l00049"></a>00049     <span class="keyword">public</span>:
<a name="l00051"></a><a class="code" href="classOgre_1_1DualQuaternion.html#a80edaf9534e9738f6125ecec0e30ca61">00051</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1DualQuaternion.html" title="Implementation of a dual quaternion, i.e.">DualQuaternion</a> ()
<a name="l00052"></a>00052             : w(1), x(0), y(0), z(0), dw(1), dx(0), dy(0), dz(0)
<a name="l00053"></a>00053         {
<a name="l00054"></a>00054         }
<a name="l00055"></a>00055         
<a name="l00057"></a><a class="code" href="classOgre_1_1DualQuaternion.html#a845da9e63d380d8b71ea6f740b7fd4a1">00057</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1DualQuaternion.html" title="Implementation of a dual quaternion, i.e.">DualQuaternion</a> (<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fW, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fX, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fY, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fZ, 
<a name="l00058"></a>00058                 <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fdW, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fdX, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fdY, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fdZ)
<a name="l00059"></a>00059             : w(fW), x(fX), y(fY), z(fZ), dw(fdW), dx(fdX), dy(fdY), dz(fdZ)
<a name="l00060"></a>00060         {
<a name="l00061"></a>00061         }
<a name="l00062"></a>00062         
<a name="l00064"></a><a class="code" href="classOgre_1_1DualQuaternion.html#a433f730b581493a9358c5b542a0bffd2">00064</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1DualQuaternion.html" title="Implementation of a dual quaternion, i.e.">DualQuaternion</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a>&amp; rot)
<a name="l00065"></a>00065         {
<a name="l00066"></a>00066             this-&gt;fromTransformationMatrix(rot);
<a name="l00067"></a>00067         }
<a name="l00068"></a>00068         
<a name="l00070"></a><a class="code" href="classOgre_1_1DualQuaternion.html#a10574bf89fef9fc12fac5ed4e8085f71">00070</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1DualQuaternion.html" title="Implementation of a dual quaternion, i.e.">DualQuaternion</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; q, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; trans)
<a name="l00071"></a>00071         {
<a name="l00072"></a>00072             this-&gt;fromRotationTranslation(q, trans);
<a name="l00073"></a>00073         }
<a name="l00074"></a>00074         
<a name="l00076"></a><a class="code" href="classOgre_1_1DualQuaternion.html#a303afd76b65bd34a28accdb6eb0c024c">00076</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1DualQuaternion.html" title="Implementation of a dual quaternion, i.e.">DualQuaternion</a>(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>* valptr)
<a name="l00077"></a>00077         {
<a name="l00078"></a>00078             memcpy(&amp;w, valptr, <span class="keyword">sizeof</span>(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>)*8);
<a name="l00079"></a>00079         }
<a name="l00080"></a>00080 
<a name="l00082"></a><a class="code" href="classOgre_1_1DualQuaternion.html#ad09ca2a40495a5ce79ab74738ce4005d">00082</a>         <span class="keyword">inline</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> operator [] ( <span class="keyword">const</span> <span class="keywordtype">size_t</span> i )<span class="keyword"> const</span>
<a name="l00083"></a>00083 <span class="keyword">        </span>{
<a name="l00084"></a>00084             assert( i &lt; 8 );
<a name="l00085"></a>00085 
<a name="l00086"></a>00086             <span class="keywordflow">return</span> *(&amp;w+i);
<a name="l00087"></a>00087         }
<a name="l00088"></a>00088 
<a name="l00090"></a><a class="code" href="classOgre_1_1DualQuaternion.html#af666d1865aa8b3467648b96e8c597217">00090</a>         <span class="keyword">inline</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>&amp; operator [] ( <span class="keyword">const</span> <span class="keywordtype">size_t</span> i )
<a name="l00091"></a>00091         {
<a name="l00092"></a>00092             assert( i &lt; 8 );
<a name="l00093"></a>00093 
<a name="l00094"></a>00094             <span class="keywordflow">return</span> *(&amp;w+i);
<a name="l00095"></a>00095         }
<a name="l00096"></a>00096         
<a name="l00097"></a><a class="code" href="classOgre_1_1DualQuaternion.html#a410cb35a3ac7a805f4628c9e62ad46f9">00097</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1DualQuaternion.html" title="Implementation of a dual quaternion, i.e.">DualQuaternion</a>&amp; operator= (<span class="keyword">const</span> <a class="code" href="classOgre_1_1DualQuaternion.html" title="Implementation of a dual quaternion, i.e.">DualQuaternion</a>&amp; rkQ)
<a name="l00098"></a>00098         {
<a name="l00099"></a>00099             w = rkQ.<a class="code" href="classOgre_1_1DualQuaternion.html#a4e1b52752fb889035e68f893f2a246c6">w</a>;
<a name="l00100"></a>00100             x = rkQ.<a class="code" href="classOgre_1_1DualQuaternion.html#a1afbb66b83f2085f452bb663ceafc9dc">x</a>;
<a name="l00101"></a>00101             y = rkQ.<a class="code" href="classOgre_1_1DualQuaternion.html#a43375b322ae7a0b7f5d03318bfa33f17">y</a>;
<a name="l00102"></a>00102             z = rkQ.<a class="code" href="classOgre_1_1DualQuaternion.html#aca62cb2fb2eeab0637b35bc920a7cae4">z</a>;
<a name="l00103"></a>00103             dw = rkQ.<a class="code" href="classOgre_1_1DualQuaternion.html#aef3bbc49149643d5bfc3dbde4064dde3">dw</a>;
<a name="l00104"></a>00104             dx = rkQ.<a class="code" href="classOgre_1_1DualQuaternion.html#a488ce81a7866d481169647cff04dc17c">dx</a>;
<a name="l00105"></a>00105             dy = rkQ.<a class="code" href="classOgre_1_1DualQuaternion.html#a123fbf0958bccd9f5381d6f124d0586e">dy</a>;
<a name="l00106"></a>00106             dz = rkQ.<a class="code" href="classOgre_1_1DualQuaternion.html#acfec8064c128940237fe204e7b0e9f99">dz</a>;
<a name="l00107"></a>00107             
<a name="l00108"></a>00108             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00109"></a>00109         }
<a name="l00110"></a>00110 
<a name="l00111"></a><a class="code" href="classOgre_1_1DualQuaternion.html#a86d06821d6faba9a8fce263605572e6f">00111</a>         <span class="keyword">inline</span> <span class="keywordtype">bool</span> <a class="code" href="group__Memory.html#gaa5b83b2ba3ce965e3d8dd129c93ee43b" title="determine equality, can memory from another allocator be released by this allocator, (ISO C++)">operator== </a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1DualQuaternion.html" title="Implementation of a dual quaternion, i.e.">DualQuaternion</a>&amp; rhs)<span class="keyword"> const</span>
<a name="l00112"></a>00112 <span class="keyword">        </span>{
<a name="l00113"></a>00113             <span class="keywordflow">return</span> (rhs.<a class="code" href="classOgre_1_1DualQuaternion.html#a4e1b52752fb889035e68f893f2a246c6">w</a> == w) &amp;&amp; (rhs.<a class="code" href="classOgre_1_1DualQuaternion.html#a1afbb66b83f2085f452bb663ceafc9dc">x</a> == x) &amp;&amp; (rhs.<a class="code" href="classOgre_1_1DualQuaternion.html#a43375b322ae7a0b7f5d03318bfa33f17">y</a> == y) &amp;&amp; (rhs.<a class="code" href="classOgre_1_1DualQuaternion.html#aca62cb2fb2eeab0637b35bc920a7cae4">z</a> == z) &amp;&amp; 
<a name="l00114"></a>00114                 (rhs.<a class="code" href="classOgre_1_1DualQuaternion.html#aef3bbc49149643d5bfc3dbde4064dde3">dw</a> == dw) &amp;&amp; (rhs.<a class="code" href="classOgre_1_1DualQuaternion.html#a488ce81a7866d481169647cff04dc17c">dx</a> == dx) &amp;&amp; (rhs.<a class="code" href="classOgre_1_1DualQuaternion.html#a123fbf0958bccd9f5381d6f124d0586e">dy</a> == dy) &amp;&amp; (rhs.<a class="code" href="classOgre_1_1DualQuaternion.html#acfec8064c128940237fe204e7b0e9f99">dz</a> == dz);
<a name="l00115"></a>00115         }
<a name="l00116"></a>00116 
<a name="l00117"></a><a class="code" href="classOgre_1_1DualQuaternion.html#a78c52f496197e1dd2fabce71e7684170">00117</a>         <span class="keyword">inline</span> <span class="keywordtype">bool</span> <a class="code" href="group__Memory.html#ga34a9308dc656f694883718bf8fa4f1c2" title="determine equality, can memory from another allocator be released by this allocator, (ISO C++)">operator!= </a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1DualQuaternion.html" title="Implementation of a dual quaternion, i.e.">DualQuaternion</a>&amp; rhs)<span class="keyword"> const</span>
<a name="l00118"></a>00118 <span class="keyword">        </span>{
<a name="l00119"></a>00119             <span class="keywordflow">return</span> !<a class="code" href="group__Memory.html#gaa5b83b2ba3ce965e3d8dd129c93ee43b" title="determine equality, can memory from another allocator be released by this allocator, (ISO C++)">operator==</a>(rhs);
<a name="l00120"></a>00120         }
<a name="l00121"></a>00121 
<a name="l00123"></a><a class="code" href="classOgre_1_1DualQuaternion.html#a61d7206748dafb2a32a0a0bf1889f74d">00123</a>         <span class="keyword">inline</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>* ptr()
<a name="l00124"></a>00124         {
<a name="l00125"></a>00125             <span class="keywordflow">return</span> &amp;w;
<a name="l00126"></a>00126         }
<a name="l00127"></a>00127 
<a name="l00129"></a><a class="code" href="classOgre_1_1DualQuaternion.html#a2085657bf1f813c4dd0dcf961059244a">00129</a>         <span class="keyword">inline</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>* ptr()<span class="keyword"> const</span>
<a name="l00130"></a>00130 <span class="keyword">        </span>{
<a name="l00131"></a>00131             <span class="keywordflow">return</span> &amp;w;
<a name="l00132"></a>00132         }
<a name="l00133"></a>00133         
<a name="l00135"></a><a class="code" href="classOgre_1_1DualQuaternion.html#a80c92016a8442946a264b8c13ba9f300">00135</a>         <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacestd.html#ac0f5c834836c0f5a4602cff74511d272" title="Implement std::swap in terms of SmallVector swap.">swap</a>(<a class="code" href="classOgre_1_1DualQuaternion.html" title="Implementation of a dual quaternion, i.e.">DualQuaternion</a>&amp; other)
<a name="l00136"></a>00136         {
<a name="l00137"></a>00137             <a class="code" href="namespacestd.html#ac0f5c834836c0f5a4602cff74511d272" title="Implement std::swap in terms of SmallVector swap.">std::swap</a>(w, other.<a class="code" href="classOgre_1_1DualQuaternion.html#a4e1b52752fb889035e68f893f2a246c6">w</a>);
<a name="l00138"></a>00138             <a class="code" href="namespacestd.html#ac0f5c834836c0f5a4602cff74511d272" title="Implement std::swap in terms of SmallVector swap.">std::swap</a>(x, other.<a class="code" href="classOgre_1_1DualQuaternion.html#a1afbb66b83f2085f452bb663ceafc9dc">x</a>);
<a name="l00139"></a>00139             <a class="code" href="namespacestd.html#ac0f5c834836c0f5a4602cff74511d272" title="Implement std::swap in terms of SmallVector swap.">std::swap</a>(y, other.<a class="code" href="classOgre_1_1DualQuaternion.html#a43375b322ae7a0b7f5d03318bfa33f17">y</a>);
<a name="l00140"></a>00140             <a class="code" href="namespacestd.html#ac0f5c834836c0f5a4602cff74511d272" title="Implement std::swap in terms of SmallVector swap.">std::swap</a>(z, other.<a class="code" href="classOgre_1_1DualQuaternion.html#aca62cb2fb2eeab0637b35bc920a7cae4">z</a>);
<a name="l00141"></a>00141             <a class="code" href="namespacestd.html#ac0f5c834836c0f5a4602cff74511d272" title="Implement std::swap in terms of SmallVector swap.">std::swap</a>(dw, other.<a class="code" href="classOgre_1_1DualQuaternion.html#aef3bbc49149643d5bfc3dbde4064dde3">dw</a>);
<a name="l00142"></a>00142             <a class="code" href="namespacestd.html#ac0f5c834836c0f5a4602cff74511d272" title="Implement std::swap in terms of SmallVector swap.">std::swap</a>(dx, other.<a class="code" href="classOgre_1_1DualQuaternion.html#a488ce81a7866d481169647cff04dc17c">dx</a>);
<a name="l00143"></a>00143             <a class="code" href="namespacestd.html#ac0f5c834836c0f5a4602cff74511d272" title="Implement std::swap in terms of SmallVector swap.">std::swap</a>(dy, other.<a class="code" href="classOgre_1_1DualQuaternion.html#a123fbf0958bccd9f5381d6f124d0586e">dy</a>);
<a name="l00144"></a>00144             <a class="code" href="namespacestd.html#ac0f5c834836c0f5a4602cff74511d272" title="Implement std::swap in terms of SmallVector swap.">std::swap</a>(dz, other.<a class="code" href="classOgre_1_1DualQuaternion.html#acfec8064c128940237fe204e7b0e9f99">dz</a>);
<a name="l00145"></a>00145         }
<a name="l00146"></a>00146         
<a name="l00148"></a><a class="code" href="classOgre_1_1DualQuaternion.html#a7f1028534850e2429921f421ecf69fe5">00148</a>         <span class="keyword">inline</span> <span class="keywordtype">bool</span> isNaN()<span class="keyword"> const</span>
<a name="l00149"></a>00149 <span class="keyword">        </span>{
<a name="l00150"></a>00150             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Math.html#a8e299aa79c3a90617cbe764ee977b703">Math::isNaN</a>(w) || <a class="code" href="classOgre_1_1Math.html#a8e299aa79c3a90617cbe764ee977b703">Math::isNaN</a>(x) || <a class="code" href="classOgre_1_1Math.html#a8e299aa79c3a90617cbe764ee977b703">Math::isNaN</a>(y) || <a class="code" href="classOgre_1_1Math.html#a8e299aa79c3a90617cbe764ee977b703">Math::isNaN</a>(z) ||  
<a name="l00151"></a>00151                 <a class="code" href="classOgre_1_1Math.html#a8e299aa79c3a90617cbe764ee977b703">Math::isNaN</a>(dw) || <a class="code" href="classOgre_1_1Math.html#a8e299aa79c3a90617cbe764ee977b703">Math::isNaN</a>(dx) || <a class="code" href="classOgre_1_1Math.html#a8e299aa79c3a90617cbe764ee977b703">Math::isNaN</a>(dy) || <a class="code" href="classOgre_1_1Math.html#a8e299aa79c3a90617cbe764ee977b703">Math::isNaN</a>(dz);
<a name="l00152"></a>00152         }
<a name="l00153"></a>00153 
<a name="l00155"></a>00155         <span class="keywordtype">void</span> fromRotationTranslation (<span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; q, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; trans);
<a name="l00156"></a>00156         
<a name="l00158"></a>00158         <span class="keywordtype">void</span> toRotationTranslation (<a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; q, <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; translation) <span class="keyword">const</span>;
<a name="l00159"></a>00159 
<a name="l00161"></a>00161         <span class="keywordtype">void</span> fromTransformationMatrix (<span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a>&amp; kTrans);
<a name="l00162"></a>00162         
<a name="l00164"></a>00164         <span class="keywordtype">void</span> toTransformationMatrix (<a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a>&amp; kTrans) <span class="keyword">const</span>;
<a name="l00165"></a>00165 
<a name="l00166"></a><a class="code" href="classOgre_1_1DualQuaternion.html#aca62cb2fb2eeab0637b35bc920a7cae4">00166</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> w, x, y, <a class="code" href="classOgre_1_1DualQuaternion.html#aca62cb2fb2eeab0637b35bc920a7cae4">z</a>, dw, dx, dy, dz;
<a name="l00167"></a>00167 
<a name="l00172"></a>00172         <span class="keyword">inline</span> <a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <span class="keyword">friend</span> std::ostream&amp; <span class="keyword">operator</span> &lt;&lt;
<a name="l00173"></a><a class="code" href="classOgre_1_1DualQuaternion.html#aa7459724aaeaf956e29b08dad3986c39">00173</a>         ( std::ostream&amp; o, <span class="keyword">const</span> <a class="code" href="classOgre_1_1DualQuaternion.html" title="Implementation of a dual quaternion, i.e.">DualQuaternion</a>&amp; q )
<a name="l00174"></a>00174         {
<a name="l00175"></a>00175             o &lt;&lt; <span class="stringliteral">&quot;DualQuaternion(&quot;</span> &lt;&lt; q.w &lt;&lt; <span class="stringliteral">&quot;, &quot;</span> &lt;&lt; q.x &lt;&lt; <span class="stringliteral">&quot;, &quot;</span> &lt;&lt; q.y &lt;&lt; <span class="stringliteral">&quot;, &quot;</span> &lt;&lt; q.z &lt;&lt; <span class="stringliteral">&quot;, &quot;</span> &lt;&lt; q.dw &lt;&lt; <span class="stringliteral">&quot;, &quot;</span> &lt;&lt; q.dx &lt;&lt; <span class="stringliteral">&quot;, &quot;</span> &lt;&lt; q.dy &lt;&lt; <span class="stringliteral">&quot;, &quot;</span> &lt;&lt; q.dz &lt;&lt; <span class="stringliteral">&quot;)&quot;</span>;
<a name="l00176"></a>00176             <span class="keywordflow">return</span> o;
<a name="l00177"></a>00177         }
<a name="l00178"></a>00178     };
<a name="l00182"></a>00182 }
<a name="l00183"></a>00183 
<a name="l00184"></a>00184 <span class="preprocessor">#endif </span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:50
</p>
</body>
</html>
